﻿var getRuleOperatorValues = "/Admin/ChatProfiles/GetRuleOperatorValues";
var getRuleEnumeratorOrDataType = "/Admin/ChatProfiles/GetRuleEnumeratorOrDataType";
var getRuleFieldValuesForSelect2 = "/Admin/ChatProfiles/GetRuleFieldValuesForSelect2";
var getActionListForSelect2 = "/Admin/ChatProfiles/GetActionFieldValuesForSelect2";
var getActionValueTypeAndOptions = "/Admin/ChatProfiles/GetActionValueTypeAndOptions";
var newConditionButton = ".btn-new-chat-profil-automation-condition";
var newActionButton = ".btn-new-automation-action";
var deleteId = -1;

$(document).ready(function () {
    $('#BackgroundColor').initColorpickerChatForm();
    $('#FontColor').initColorpickerChatForm();
    $('#ButtonColor').initColorpickerChatForm();
    $('#ButtonBackgroundColor').initColorpickerChatForm();
    $('#BorderColor').initColorpickerChatForm();
    $('#BorderButtonColor').initColorpickerChatForm();
    $('#OperatorMessageBackgroundColor').initColorpickerChatForm();
    $('#OperatorMessageTextColor').initColorpickerChatForm();
    $('#GuestMessageBackgroundColor').initColorpickerChatForm();
    $('#GuestMessageTextColor').initColorpickerChatForm();
    $('#HighlighterBorderColor').initColorpickerChatForm();
    $('#HighlighterBackgroundColor').initColorpickerChatForm();
    $('#HighlighterTextColor').initColorpickerChatForm();

    $("#BackgroundColorValue").trigger("change");
    $("#FontColorValue").trigger("change");
    $("#BorderRadiusSlider").slider({
        min: 0,
        max: 30,
        slide: function (event, ui) {
            $(".rectangle-display-style").css("border-top-right-radius", ui.value);
            $(".rectangle-display-style").css("border-top-left-radius", ui.value);
            $("#BorderRadius").val(ui.value);
        }
    });
    $("#NewMessageVolumeSlider").slider({
        min: 0,
        max: 100,
        slide: function (event, ui) {
            $("#NewMessageVolume").val(ui.value);
        }
    });
    $("#NewChatVolumeSlider").slider({
        min: 0,
        max: 100,
        slide: function (event, ui) {
            $("#NewChatVolume").val(ui.value);
        }
    });
    $("#BorderRadiusSlider").slider("value", $("#BorderRadius").val());
    $(".rectangle-display-style").css("border-color", $("#BorderButtonColorValue").val());
    $(".rectangle-display-style").css("border-top-right-radius", Number($("#BorderRadius").val()));
    $(".rectangle-display-style").css("border-top-left-radius", Number($("#BorderRadius").val()));
    $("#NewChatVolumeSlider").slider("value", $("#NewChatVolume").val());
    $("#NewMessageVolumeSlider").slider("value", $("#NewMessageVolume").val());
    $("#SelectedLanguage").change(function (e) {
        var isNew = $("#IsNew").val().toLowerCase() === "true";
        $.get(isNew ? "LoadTexts" : "../LoadTexts", { chatProfileId: $("#Id").val(), langTag: $(this).val(), isNew: isNew }, function (data) {
            $("#ChatWindow").val(data ? data.ChatWindow : "");
            $("#ChatButton").val(data ? data.ChatButton : "");
            $("#ChatButtonOffline").val(data ? data.ChatButtonOffline : "");
            $("#WaitForOperatorsComing").val(data ? data.WaitForOperatorsComing : "");
            $("#AllOperatorsAreBusy").val(data ? data.AllOperatorsAreBusy : "");
            $("#WaitForSessionsQueue").val(data ? data.WaitForSessionsQueue : "");
            $("#YourQueueOrder").val(data ? data.YourQueueOrder : "");
            $("#FormWelcome").val(data ? data.FormWelcome : "");
            $("#FormWelcomeOffline").val(data ? data.FormWelcomeOffline : "");
            $("#OpeningHoursInfo").val(data ? data.OpeningHoursInfo : "");
            $("#FormButtonForStarting").val(data ? data.FormButtonForStarting : "");
            $("#FormSendMessage").val(data ? data.FormSendMessage : "");
            $("#ChatWhenFormPosted").val(data ? data.ChatWhenFormPosted : "");
            $("#ChatFirstMessage").val(data ? data.ChatFirstMessage : "");
            $("#HighlighterText").val(data ? data.HighlighterText : "");
        }, "json");
    });
    
    $("#SelectedFieldLanguage").change(function (e) {
        $("#dialog-form").find("input[type='text']:not('.tbItemText')").val($(actualEditElement).find("input[data-langtag='" + $(this).val() + "']").val());
    });

    $("input[name='EnableForm']").change(function () {
        if (this.value.toLowerCase() === "true") {
            if ($("#EmailShow").val().toLowerCase() === "true")
                $("#MissedChatUserProviderKeysAndEmailsPanel").show();
            $("#chatProfileForm").show();
        }
        else {
            $("#MissedChatUserProviderKeysAndEmailsPanel").hide();
            $("#chatProfileForm").hide();
        }
    });

    $("input[name='EnableOffLineForm']").change(function () {
        if (this.value.toLowerCase() === "true")
            $("#chatProfileOfflineForm").show();
        else
            $("#chatProfileOfflineForm").hide();
    });
   

    $("#EnableVideo").prop("disabled", !$("#EnableAudio").is(":checked"));
    $("#EnableAudio").change(function () {
        $("#EnableVideo").prop("disabled", !$("#EnableAudio").is(":checked"));
        $("#EnableVideo").prop("checked", false);
    });

    $("body").on("change", "#FormWelcome", function () {
        $("#FormTextSubtitle").text($(this).val());
    });

    $("body").on("change", "#ChatWindow", function () {
        $("#ChatWindowText").text($(this).val());
    });

    $("body").on("change", "#ChatButton", function () {
        $("#ChatWindowTextIcon").text($(this).val());
    });

    $("dialog-chat-profile-automation").dialog({
        autoOpen: false,
        resizable: true,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Save,
            click: function () {
                $("dialog-chat-profile-automation").dialog("close");
            }
        }, {
            text: Localization_Close,
            click: function () {
                $("dialog-chat-profile-automation").dialog("close");
            }
        }]
    });

    $("body").on("change", ".conditions .condition-for-automation-event .column-type:not(.select2-container)", function () {
        conditionFieldChanged($(this).closest(".condition-for-automation-event"));
    });
    
    $("body").on("click", ".btn-new-chat-profil-automation-condition", function () {
        addNewFiltr();
    });

    $("body").on("click", ".conditions .add-button", function () {
        addNewFiltr();
    });

    $("body").on("click", ".btn-new-automation-action", function () {
        addNewAction();
    });

    $("body").on("click", ".automatic-actions .add-action-button", function () {
        addNewAction();
    });

    $("body").on("change", ".action-for-automation-event .action-type:not(.select2-container)", function () {
        actionFieldChanged($(this).closest(".action-for-automation-event"));
    });

    $("body").on("click", ".conditions .delete-button", function () {
        deleteCondition($(this));
        if ($(".conditions .condition-for-automation-event").length === 0) {
            $(".btn-new-chat-profil-automation-condition").show();
        }
    });

    $("body").on("click", ".automatic-actions .delete-action-button", function () {
        $(this).closest(".action-for-automation-event").remove();
        if ($(".automatic-actions .action-for-automation-event").length === 0) {
            $(".btn-new-automation-action").show();
        }
    });

    $("body").on("click", ".soundButton", function () {
        var $soundidVal = $("#" + $(this).data("soundid")).val();
        var soundname = "";
        if (!$soundidVal) {
            return;
        } else if ($soundidVal == 1) {
            soundname = "Sound1.mp3";
        } else if ($soundidVal == 2) {
            soundname = "Sound2.mp3";
        } else if ($soundidVal == 3) {
            soundname = "Sound3.mp3";
        } else if ($soundidVal == 4) {
            soundname = "Sound4.mp3";
        } else if ($soundidVal == 5) {
            soundname = "Sound5.mp3";
        }
        $.playSound(RQ_URL + '/Sounds/ChatProfileSounds/' + soundname, $("#" + $(this).data("volumeid")).val() / 100);
    });

    $("#SelectedCalendar").change(function () {
        $("#EnableCalendarInfo").prop("disabled", !$("#SelectedCalendar").val());
    });

    ReloadAnswerTable();
});

function Save() {
    $(".valid-error").hide();
    var selectedMenu = $(".active a").data("type");
    if (selectedMenu == "1") {
        return SaveVisibility();
    }
    else if (selectedMenu == "2") {
        return SaveTexts();
    }
    else if (selectedMenu == "3") {
        return SaveForm();
    }
    else if (selectedMenu == "4") {
        return SaveInstalation();
    }
    else if (selectedMenu == "5") {
        return SaveSettings();
    }
    else if (selectedMenu == "6") {
        return SaveOperators();
    }
    else if (selectedMenu == "7") {
        return SaveCalendar();
    }
    else if (selectedMenu == "8") {
        return SaveAutomation();
    }
    else if (selectedMenu == "9") {
        return SaveSounds();
    }
    else if (selectedMenu == "10") {
        return SaveAnswer();
    }
    return false;
}

function processSuccessfulSave(g)
{
    if (g != null) {
        $("#IsNew").val("False");
        $("#Id").val(g.Id);
        SetInstallScript(g.Key);
        SetChatWidgetLink(g.Key);
        ShowSuccess("Změny byly uloženy");
    }
}
function SaveAnswer() {
    if (IsAnswerValid()) {
        $.ajax({
            url: RQ_URL + "/Admin/ChatProfiles/SaveAnswer",
            type: "POST",
            data: JSON.stringify({
                New: $("#IsNew").val(),
                Id: $("#Id").val(),
                IsInternal: $("#IsInternal").val(),
                Name: $("#ChatProfileName").val(),
                AnswerId: $("#AnswerId").val(),
                AnswerIsNew: $("#AnswerIsNew").val(),
                Shortcut: $("#AnswerShortcut").val(),
                Text: $("#AnswerText").val(),
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: processSuccessfulSave,
            error: function (error) { alert(error.responseText); },
            complete: function () {
                NewAnswerHidden();
                ReloadAnswerTable();
            }
        });
        return true;
    }
    return false;
}

function IsAnswerValid() {
    var valid = true;

    if ($("#ChatProfileName").val() == "") {
        valid = false;
        $("#ChatProfileName").focus();
        $("#ChatProfileName").closest(".form-group").find(".valid-error").show();
    }
    if ($("#AnswerShortcut").val() == "" || $("#AnswerShortcut").val().length > 20 || $("#AnswerShortcut").val().trim() != $("#AnswerShortcut").val().trim().replace(/[^\w\-]/gi, '')) {
        valid = false;
        $("#AnswerShortcut").focus();
        $("#AnswerShortcut").closest(".form-group").find(".valid-error").show();
    }
    if ($("#AnswerText").val() == "") {
        valid = false;
        $("#AnswerText").focus();
        $("#AnswerText").closest(".form-group").find(".valid-error").show();
    }

    return valid;
}

function SaveSounds() {
    if (IsSoundsValid()) {
        $.ajax({
            url: RQ_URL + "/Admin/ChatProfiles/SaveSounds",
            type: "POST",
            data: JSON.stringify({
                New: $("#IsNew").val(),
                Id: $("#Id").val(),
                IsInternal: $("#IsInternal").val(),
                Name: $("#ChatProfileName").val(),
                NewChatSound: $("#SelectedSoundNewChat").val(),
                NewChatSoundVolume: $("#NewChatVolume").val(),
                NewMessageSound: $("#SelectedSoundNewMessage").val(),
                NewMessageSoundVolume: $("#NewMessageVolume").val(),
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: processSuccessfulSave,
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
        return true;
    }
    return false;
}

function IsSoundsValid() {
    var valid = true;

    if ($("#ChatProfileName").val() == "") {
        valid = false;
        $("#ChatProfileName").focus();
        $("#ChatProfileName").closest(".form-group").find(".valid-error").show();
    }

    return valid;
}

function SaveVisibility() {
    if (IsVisibilityValid()) {
        $.ajax({
            url: RQ_URL + "/Admin/ChatProfiles/SaveVisibility",
            type: "POST",
            data: JSON.stringify({
                New: $("#IsNew").val(),
                Id: $("#Id").val(),
                IsInternal: $("#IsInternal").val(),
                Name: $("#ChatProfileName").val(),
                BackgroundColor: $("#BackgroundColorValue").val(),
                Color: $("#FontColorValue").val(),
                Position: $(":radio[name='Position']:checked").val(),
                DisplayStyle: $(":radio[name='DisplayStyle']:checked").val(),
                BorderColor: $("#BorderColorValue").val(),
                ButtonBackgroundColor: $("#ButtonBackgroundColorValue").val(),
                ButtonColor: $("#ButtonColorValue").val(),
                OperatorMessageBackgroundColor: $("#OperatorMessageBackgroundColorValue").val(),
                OperatorMessageTextColor: $("#OperatorMessageTextColorValue").val(),
                GuestMessageBackgroundColor: $("#GuestMessageBackgroundColorValue").val(),
                GuestMessageTextColor: $("#GuestMessageTextColorValue").val(),
                HighlighterBorderColor: $("#HighlighterBorderColorValue").val(),
                HighlighterBackgroundColor: $("#HighlighterBackgroundColorValue").val(),
                HighlighterTextColor: $("#HighlighterTextColorValue").val(),
                BorderRadius: $("#BorderRadius").val(),
                BorderButtonColor: $("#BorderButtonColorValue").val(),
                WindowSize: $(":radio[name='WindowSize']:checked").val()
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: processSuccessfulSave,
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
        return true;
    }
    return false;
}

function IsVisibilityValid() {
    var valid = true;

    if ($("#BackgroundColorValue").val() == "") {
        valid = false;
        $("#BackgroundColorValue").focus();
        $("#BackgroundColorValue").closest(".form-group").find(".valid-error").show();
    }
    if ($("#FontColorValue").val() == "") {
        valid = false;
        $("#FontColorValue").focus();
        $("#FontColorValue").closest(".form-group").find(".valid-error").show();
    }
    if ($("#ChatProfileName").val() == "") {
        valid = false;
        $("#ChatProfileName").focus();
        $("#ChatProfileName").closest(".form-group").find(".valid-error").show();
    }

    return valid;
}

function SaveTexts() {
    if (IsTextValid()) {
        $.ajax({
            url: RQ_URL + "/Admin/ChatProfiles/SaveTexts",
            type: "POST",
            data: JSON.stringify({
                New: $("#IsNew").val(),
                Id: $("#Id").val(),
                IsInternal: $("#IsInternal").val(),
                Name: $("#ChatProfileName").val(),
                LangTag: $("#SelectedLanguage").val(),
                ChatWindow: $("#ChatWindow").val(),
                ChatButton: $("#ChatButton").val(),
                ChatButtonOffline: $("#ChatButtonOffline").val(),
                WaitForOperatorsComing: $("#WaitForOperatorsComing").val(),
                AllOperatorsAreBusy: $("#AllOperatorsAreBusy").val(),
                WaitForSessionsQueue: $("#WaitForSessionsQueue").val(),
                YourQueueOrder: $("#YourQueueOrder").val(),
                FormWelcome: $("#FormWelcome").val(),
                FormWelcomeOffline: $("#FormWelcomeOffline").val(),
                OpeningHoursInfo: $("#OpeningHoursInfo").val(),
                FormButtonForStarting: $("#FormButtonForStarting").val(),
                FormSendMessage: $("#FormSendMessage").val(),
                ChatWhenFormPosted: $("#ChatWhenFormPosted").val(),
                ChatFirstMessage: $("#ChatFirstMessage").val(),
                HighlighterText: $("#HighlighterText").val()
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: processSuccessfulSave,
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
        return true;
    }
    return false;
}

function IsTextValid() {
    var valid = true;

    if ($("#ChatProfileName").val() == "") {
        valid = false;
        $("#ChatProfileName").focus();
        $("#ChatProfileName").closest(".form-group").find(".valid-error").show();
    }
    if ($("#ChatWindow").val() == "") {
        valid = false;
        $("#ChatWindow").focus();
        $("#ChatWindow").closest(".form-group").find(".valid-error").show();
    }
    if ($("#ChatButton").val() == "") {
        valid = false;
        $("#ChatButton").focus();
        $("#ChatButton").closest(".form-group").find(".valid-error").show();
    }
    if ($("#ChatButtonOffline").val() == "") {
        valid = false;
        $("#ChatButtonOffline").focus();
        $("#ChatButtonOffline").closest(".form-group").find(".valid-error").show();
    }

    return valid;
}

function SaveForm() {
    if (IsFormValid()) {
        $.ajax({
            url: RQ_URL + "/Admin/ChatProfiles/SaveCustomForm",
            type: "POST",
            data: JSON.stringify({
                CustomFormFields: getCustomFormFieldData(),
                New: $("#IsNew").val(),
                Id: $("#Id").val(),
                IsInternal: $("#IsInternal").val(),
                Name: $("#ChatProfileName").val(),
                Enabled: $("#EnableForm").is(":checked"),
                NameShow: $("#NameShow").val(),
                NameRequired: $("#NameRequired").val(),
                EmailShow: $("#EmailShow").val(),
                EmailRequired: $("#EmailRequired").val(),
                TelephoneShow: $("#TelephoneShow").val(),
                TelephoneRequired: $("#TelephoneRequired").val(),
                EnableOffLineForm: $("#ChatProfileOffLineEnabled").is(":checked"),
                EnableSendEmail: $("#chbEnableSendEmail").is(":checked"),
                MissedChatEnableSendEmail: $("#chbMissedChatEnableSendEmail").is(":checked"),
                UserProviderKeysAndEmails: $("#UserProviderKeysAndEmails").val(),
                MissedChatUserProviderKeysAndEmails: $("#MissedChatUserProviderKeysAndEmails").val(),
                EnableCreateTicket: $("#chbEnableCreateTicket").is(":checked"),
                TicketType: $("#ddlTicketTypes").val(),
                ServiceId: $("#ddlServices").val(),
                MailboxId: $("#ddlMailboxes").val(),
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: processSuccessfulSave,
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
        return true;
    }
    return false;
}

function IsFormValid() {
    var valid = true;

    if ($("#ChatProfileName").val() == "") {
        valid = false;
        $("#ChatProfileName").focus();
        $("#ChatProfileName").closest(".form-group").find(".valid-error").show();
    }

    if ($("#EnableForm").is(":checked")) {
        if ($("#chbMissedChatEnableSendEmail").is(":checked") && $("#MissedChatUserProviderKeysAndEmails").val() == null) {
            valid = false;
            $("#MissedChatUserProviderKeysAndEmails").focus();
            $("#MissedChatUserProviderKeysAndEmails").closest(".margin-left-big").find(".valid-error").show();
        }
    }

    if ($("#ChatProfileOffLineEnabled").is(":checked")) {
        if (!$("#chbEnableCreateTicket").is(":checked") && !$("#chbEnableSendEmail").is(":checked")) {
            valid = false;
            $("#chbEnableSendEmail").focus();
            $("#chatProfileOfflineForm ~ .valid-error").show();
        }

        if ($("#chbEnableSendEmail").is(":checked") && $("#UserProviderKeysAndEmails").val() == null) {
            valid = false;
            $("#UserProviderKeysAndEmails").focus();
            $("#UserProviderKeysAndEmails").closest(".margin-left-big").find(".valid-error").show();
        }
        
        if ($("#chbEnableCreateTicket").is(":checked")) {
            if ($("#ddlTicketTypes").val() > 1 && $("#ddlServices").val() === null) {
                valid = false;
                $("#ddlServices").focus();
                $("#ddlServices").closest("td").find(".valid-error").show();
            }

            if (!$("#ddlMailboxes").val()) {
                valid = false;
                $("#ddlMailboxes").focus();
                $("#ddlMailboxes").closest("td").find(".valid-error").show();
            }
        }
    }
        

    return valid;
}

function SaveInstalation() {
    return true;
}

function SaveSettings() {
    if (IsSettingsValid()) {
        $.ajax({
            url: RQ_URL + "/Admin/ChatProfiles/SaveSettings",
            type: "POST",
            data: JSON.stringify({
                New: $("#IsNew").val(),
                Id: $("#Id").val(),
                IsInternal: $("#IsInternal").val(),
                Name: $("#ChatProfileName").val(),
                EnableVideo: $("#EnableVideo").is(":checked"),
                EnableAudio: $("#EnableAudio").is(":checked"),
                EnableHighlighter: $("#EnableHighlighter").is(":checked"),
                ShowChatType: $(":radio[name='DisplayStyle']:checked").val(),
                CalendarId: $("#SelectedCalendar").val()
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: processSuccessfulSave,
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
        return true;
    }
    return false;
}

function IsSettingsValid() {
    var valid = true;

    if ($("#ChatProfileName").val() == "") {
        valid = false;
        $("#ChatProfileName").focus();
        $("#ChatProfileName").closest(".form-group").find(".valid-error").show();
    }

    return valid;
}

function SaveOperators() {
    if (IsOperatorsValid()) {
        $.ajax({
            url: RQ_URL + "/Admin/ChatProfiles/SaveOperators",
            type: "POST",
            data: JSON.stringify({
                Operators: $("#Operators").val(),
                OperatorGroups: $("#OperatorGroups").val(),
                MaxChatsPerOperator: $("#ChatProfileMaxChatsPerOperator").val(),
                New: $("#IsNew").val(),
                Id: $("#Id").val(),
                IsInternal: $("#IsInternal").val(),
                Name: $("#ChatProfileName").val(),
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: processSuccessfulSave,
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
        return true;
    }
    return false;
}

function IsOperatorsValid() {
    if ($("#ChatProfileName").val() == "") {
        $("#ChatProfileName").focus();
        $("#ChatProfileName").closest(".form-group").find(".valid-error").show();
        return false;
    }

    var valid = true;
    var value = $("#ChatProfileMaxChatsPerOperator").val().trim();

    if (value.split(" ").length > 1)
        valid = false;
    else {
        var number = Number(value);
        if (!Number.isInteger(number) || number < 0 || number > 999)
            valid = false;
    }

    if (!valid) {
        $("#ChatProfileMaxChatsPerOperator").focus();
        $("#ChatProfileMaxChatsPerOperator").closest(".form-group").find(".valid-error").show();
    }

    return valid;
}

function SetInstallScript(key) {
    $("#installScript").text("<script type='text/javascript' defer>\n\
        window.requestor || (function(d) {\n\
            var s, c, o = requestor = function() {\n\
                o._.push(arguments)\n\
            };\n\
            o._ = [];\n\
            s = d.getElementsByTagName('script')[0];\n\
            c = d.createElement('script');\n\
            c.type = 'text/javascript';\n\
            c.charset = 'utf-8';\n\
            c.async = true;\n\
            c.src = '" + BASE_URL + "/Chat/ChatWidgetLoader/" + key + "'\n\
            s.parentNode.insertBefore(c, s);\n\
        })(document);\n</script>");
}

function SetChatWidgetLink(key) {
    $("#chatWidgetLink").val(BASE_URL + "/Chat/ChatWidget/" + key);
}

function SaveCalendar() {
    $.ajax({
        url: RQ_URL + "/Admin/ChatProfiles/SaveCalendar",
        type: "POST",
        data: JSON.stringify({
            New: $("#IsNew").val(),
            Id: $("#Id").val(),
            IsInternal: $("#IsInternal").val(),
            Name: $("#ChatProfileName").val(),
            Calendar: $("#SelectedCalendar").val(),
            EnableCalendarInfo: $("#EnableCalendarInfo").is(":checked")
        }),
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        success: processSuccessfulSave,
        error: function (error) { alert(error.responseText); }
    });
}

function SaveAutomation() {
    var isAutomationValid = IsAutomationValid();
    var resultCondition = findSubcondition($(".conditions").children(".condition-for-automation-event"));
    renameActions();
    var areActionsValid = AreActionsValid();

    if (isAutomationValid && resultCondition && areActionsValid) {
        $.ajax({
            url: RQ_URL + "/Admin/ChatProfiles/SaveAutomation",
            type: "POST",
            data: JSON.stringify({
                IsNew: $("#IsNew").val(),
                Id: $("#Id").val(),
                IsInternal: $("#IsInternal").val(),
                Name: $("#ChatProfileName").val(),
                AutomationName: $("#AutomationName").val(),
                AutomationId: $("#AutomationId").val(),
                AutomationIsNew: $("#AutomationIsNew").val(),
                Events: EventDataForSubmit(),
                Actions: getActionData(),
                Conditions: findSubconditionData($(".conditions").children(".condition-for-automation-event"), undefined),
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: processSuccessfulSave,
            error: function (error) { alert(error.responseText); },
            complete: function () {
                NewAutomationHidden();
                ReloadTable();
            }
        });
        return true;
    }
    return false;
}
function EventDataForSubmit() {
    var data = new Array();
    $($(".event").find("select")).each(function (index, value) {
        data.push({
            Event: $(value).val()
        });
    })

    return data;
}

function IsAutomationValid() {
    var valid = true;

    if ($("#ChatProfileName").val() == "") {
        valid = false;
        $("#ChatProfileName").focus();
        $("#ChatProfileName").closest(".form-group").find(".valid-error").show();
    }
    if ($("#AutomationName").val() == "") {
        valid = false;
        $("#AutomationName").focus();
        $("#AutomationName").closest(".form-group").find(".valid-error").show();
    }
    if ($(".automatic-actions .action-for-automation-event").length == 0) {
        valid = false;
        $("#lbNoActionError").show();
    }

    return valid;
}

function AutomationTableHidden() {
    $(".automationTable").hide();
    $(".newAutomation").show();
    $(".newAutomation").html("<div class='loading-32'></div>");
    $(".newAutomation").load(RQ_URL + "/Admin/ChatProfiles/LoadNewOrEdit");
}

function NewAutomationHidden() {
    $(".newAutomation").hide();
    $(".automationTable").show();
}

function NewAnswerHidden() {
    $(".newanswer").hide();
    $(".answerTable").show();
}

function AnswerTableHidden() {
    $(".answerTable").hide();
    $(".newanswer").html("<div class='loading-32'></div>");
    $(".newanswer").show();
    $(".newanswer").load(RQ_URL + "/Admin/ChatProfiles/LoadNewOrEditAnswer");
}

function ReloadTable() {
    $("#TableDiv").load(RQ_URL + "/Admin/ChatProfiles/LoadTable/" + $("#Id").val());
}

function ReloadAnswerTable() {
    $("#AnswerTableDiv").load(RQ_URL + "/Admin/ChatProfiles/LoadAnswerTable/" + $("#Id").val());
}

function deleteChatAnswer(id) {
    deleteId = id;
    $("#dialog-confirm-answer").dialog("open");
}

function editChatAnswer(id) {
    $(".answerTable").hide();
    $(".newanswer").html("<div class='loading-32'></div>");
    $(".newanswer").show();
    $(".newanswer").load(RQ_URL + "/Admin/ChatProfiles/LoadNewOrEditAnswer/" + id);
}

function editChatAutomation(id) {
    $(".automationTable").hide();
    $(".newAutomation").show();
    $(".newAutomation").html("<div class='loading-32'></div>");
    $(".newAutomation").load(RQ_URL + "/Admin/ChatProfiles/LoadNewOrEdit/" + id);
}

function deleteChatAutomation(id) {
    deleteId = id;
    $("#dialog-confirm").dialog("open");
}

function cloneChatAutomation(id) {
    $.post(
        RQ_URL + "/Admin/ChatProfiles/CloneAutomation",
        $.param(
            {
                id: id,
            },
            true
        ),
        function (data) {
        },
        "json"
        )
        .error(function (error) { alert(error.responseText); })
        .success(function () { })
        .done(function () {
            $('.tooltip').hide();
            ReloadTable();
        });
}

function InitSortableAutomationEventRows() {
    $("#tableBodyOfAutomationEvent").sortable({
        handle: ".handle",
        update: function (event, ui) {
            var data = $(this).sortable('toArray', { attribute: 'data-chatautomation-id' });

            $.post(
                RQ_URL + "/Admin/ChatProfiles/SortAutomationEvent",
                $.param(
                    { sortedIds: data },
                    true
                ),
                function (data) {
                },
                "json"
                )
                .error(function (error) { alert(error.responseText); })
                .success(function () { })
                .done(function () { });
        }
    });
}

$.fn.initColorpickerChatForm = function () {
    $(this).colorpicker({
        colorSelectors: {
            '#FAF6BD': '#FAF6BD',
            '#C4E2B8': '#C4E2B8',
            '#AFE0EC': '#AFE0EC',
            '#CFBCDC': '#CFBCDC',
            '#F4C0CB': '#F4C0CB',
            '#FAFAFA': '#FAFAFA',
        }
    })
    .on('changeColor', function (event) {
        var color = event.color;
        color.a = '0.9';
        if ($(event.target).attr("id") == "BackgroundColor") {
            $("#Circle").css("fill", $("#BackgroundColorValue").val());
            $(".rectangle-display-style").css("background", $("#BackgroundColorValue").val());
            $(".chat-profile-left-box .title").css("background", $("#BackgroundColorValue").val());
        }
        else if ($(event.target).attr("id") == "FontColor")
        {
            $("#CirclePath").css("stroke", $("#FontColorValue").val());
            $(".rectangle-display-style").css("color", $("#FontColorValue").val());
            $(".chat-profile-left-box .title").css("color", $("#FontColorValue").val());
        }
        else if ($(event.target).attr("id") == "BorderButtonColor") {
            $(".rectangle-display-style").css("border-color", $("#BorderButtonColorValue").val());
        }
    })
    .on('hidePicker', function (event) {
    });
}