﻿var revert = false;
var getRuleOperatorValues = "/Tickets/GetConditionOperators";
var getRuleEnumeratorOrDataType = "/Tickets/GetRuleEnumeratorOrDataType";
var getRuleFieldValuesForSelect2 = "/Tickets/GetConditionsForSelect";
var newConditionButton = ".btn-new-automation-condition";

$(document).ready(function () {
    $(".conditions").on("change", ".condition-for-automation-event .column-type:not(.select2-container)", function () {
        conditionFieldChanged($(this).closest(".condition-for-automation-event"));
    });

    $("body").on("click", ".btn-new-automation-condition", function () {
        addNewFiltr();
    });

    $(".conditions").on("click", ".add-button", function () {
        addNewFiltr();
    });

    $(".conditions").on("click", ".delete-button", function () {
        deleteCondition($(this));
        if ($(".conditions .condition-for-automation-event").length == 0) {
            $(".btn-new-automation-condition").show();
        }
    });

    $("#AutomaticTicketAssignment").submit(function (event) {
        var resultCondition = findSubcondition($(".conditions").children(".condition-for-automation-event"));
        return resultCondition;
    });

    //nastavení
    $(".searchable100Template").select2({
        width: '100%',
        templateSelection: function (service) {
            var name = $('<div/>').html($(service.element).data("name")).text();
            var element = $(service.element).parent();
            while (element.is("option") || element.is("optgroup")) {
                name = $(element).data("name") + "/" + name;
                element = $(element).parent();
            }
            return name;
        },
    });

    $("input[name=SolversScope]").change(function () {
        var operatorsByTicketService = $(this).val() == 'OperatorsByTicketService';
        var allOperators = $(this).val() == 'AllOperators';
        var operatorsFromGroups = $(this).val() == 'OperatorsFromGroups';
        var operatorsFromServices = $(this).val() == 'OperatorsFromServices';
        var selectedOperators = $(this).val() == 'SelectedOperators';

        $("#SelectedOperatorGroups").prop("disabled", !operatorsFromGroups);
        $("#SelectedServices").prop("disabled", !operatorsFromServices);
        $("#SelectedOperators").prop("disabled", !selectedOperators);
    });

    $("#SelectedOperators").select2({
        minimumInputLength: 0,
        multiple: true,
        width: '100%',
        placeholder: Localization_Operators,
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    includeEndUsers: false,
                    includeSmartUsers: false,
                    showEmail: true,
                    pageNum: params.page || 1,
                    term: params.term,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
    });
});